// This just works with one variable from the Game Dash.
int ShiftPoint = 4000;
int RpmSimTools = 0;

int LimitRange = 0;
int UnderShiftPoint;
int OverShiftPoint;
int OverShift;
int UnderShift;

int ButtonState;
int LastButtonState = LOW;
long lastDebounceTime = 0;
long debounceDelay = 5;

int bufferArray[6];

void setup(){
  
  pinMode(3,OUTPUT);
  pinMode(4,OUTPUT);
  pinMode(5,OUTPUT);
  pinMode(6,INPUT);
  
  Serial.begin(9600);
}

void loop(){ 
  //****************************** READ DATA FROM SERIAL ******************************
  CheckButtonPress();
  CheckShiftLightAdj();
  SetLimits();
  DisplayLeds();
  ReadData();
}
 
 void ReadData(){
  
  if (Serial.available() == 6)  {    //if 6 bits available in the Serial buffer...
        
        int i;
        for (i=0; i<6; i=i+1) {       // read and label each byte.
         bufferArray[i] = Serial.read();
         }
        
         if (bufferArray[0]  == 'R'){
           RpmSimTools = ((bufferArray[1]-48)*10000) + ((bufferArray[2]-48)*1000) + // Take values 1-5.
                               ((bufferArray[3]-48)*100) + ((bufferArray[4]-48)*10) + (bufferArray[5]-48);  
           //Serial.print("You have set the Rpm to a Value of:");     
           //Serial.println(RpmSimTools);
       }
  }
}

void CheckButtonPress() {
  int reading = digitalRead(6);
  if (reading != LastButtonState){
    lastDebounceTime = millis();
  }
  if ((millis() - lastDebounceTime) > debounceDelay) {
    if (reading != ButtonState){
      ButtonState = reading;
      if (ButtonState == HIGH){
        ShiftPoint = RpmSimTools;
        //Serial.print("Button pressed");
      }
    }
  }
        LastButtonState = reading;
}
void CheckShiftLightAdj() {
  LimitRange = analogRead(0);
  int RpmAdjust = map(LimitRange, 1, 1023, 0, 2000);
  UnderShift = RpmAdjust;
  OverShift = RpmAdjust;
}

void SetLimits() {
  UnderShiftPoint = ShiftPoint - UnderShift;
  OverShiftPoint = ShiftPoint + OverShift;
}

void DisplayLeds(){
    if (RpmSimTools >= UnderShiftPoint){digitalWrite(3,HIGH);}
    if (RpmSimTools >= ShiftPoint){digitalWrite(4,HIGH);}
    if (RpmSimTools >= OverShiftPoint){digitalWrite(5,HIGH);} 
     
    if (RpmSimTools < UnderShiftPoint){digitalWrite(3,LOW);}
    if (RpmSimTools < ShiftPoint){digitalWrite(4,LOW);}
    if (RpmSimTools < OverShiftPoint){digitalWrite(5,LOW);}
}   
